.nolist
#include   "app.inc"
defpage(0,"OmniRPG")
#define    TASM
#define    bcall(xxxx)     rst 28h \ .dw xxxx
#define    equ .equ
#include   "omnirpg\omnirpg.inc"


.list
Start:
     jp Main            ;4080h
JumpTable:
Main:
     di
     ld a,41h
     ld i,a
     im 2
     ei
     ld a,20h
     out (16),a
     call LoadSave
     out (16),a
softreset:
     res mapmode,(iy+textflags)
     res drawmap,(iy+asmflags)
     ld hl,mainscreen
     ld bc,768
     ld (primarybufptr),hl
     add hl,bc
     ld (secondarybufptr),hl
     res gray,(iy+asmflags)

     call WhileKey
     set lcdupdate,(iy+asmflags)
MainScreenWait:
     halt
     call GetKeyDebounced
     cp 9
     jr nz,MainScreenWait
     res lcdupdate,(iy+asmflags)
     ld a,5
     out (16),a
     ld hl,plotSScreen
     ld (primarybufptr),hl
     ld (DrawBufPtr),hl
     res gray,(iy+asmflags)
     xor a
MainScreenSelect:
     call DispMain
     ld l,a
     call WhileKey
     ld a,l

     or a \ jp z,Continue
     jp m,softreset
     dec a \ jp z,Load
     dec a \ jp z,New
     dec a \ call z,Options
     dec a \ jp z,Exit
     jr MainScreenSelect
Exit:
     di
     ld de,3072
     ld hl,saveloc
     bcall(4357h)
     bcall(_ExitApp)
#IF $ > 4100h
.echo $-4100h," bytes to remove for the interrupt vector!"
#ENDIF
#IF $ < 4100h
.echo 4100h-$," bytes to add for the interrupt vector!"
#ENDIF
InterruptTable:
     .db 42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h
     .db 42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h
     .db 42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h
     .db 42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h
     .db 42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h
     .db 42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h
     .db 42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h
     .db 42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h
     .db 42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h
     .db 42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h
     .db 42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h
     .db 42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h
     .db 42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h
     .db 42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h
     .db 42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h
     .db 42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h,42h
     .db 42h

IncAHL:
     inc h
     ret p
     inc a
     ld h,40h
     ret
;===============================================================
GetKey:
;===============================================================
;Outputs:
;     a is a value from 0 to 56 that is the keypress
;    bc is also the key press
;     d has a bit reset, the rest are set (this is the last key group tested)
;     e is a divided by by 8
;    hl is not modified
;===============================================================
          ld bc,0             ;010000    ;10
          ld de,$7FFF         ;11FF7F    ;10
KeyLoop:                                 ;
            rlc d             ;CB02      ;8
            ld a,d            ;7A        ;4
            out (1),a         ;D301      ;12
            inc e             ;1C        ;4
            sub 7Fh           ;D67F      ;7
            ret z             ;C8        ;5|11
            nop               ;00        ;4
            in a,(1)          ;DB01      ;12
            inc a             ;3C        ;4
            jr z,KeyLoop      ;28EC      ;7|12
            dec a             ;3D        ;4
              inc c           ;0C        ;4
              rra             ;1F        ;4
              jr c,$-2        ;38FC      ;7|12
            ld a,e            ;7B        ;4
            rlca \ rlca \ rlca;070707    ;12
            add a,c           ;81        ;4
            ld c,a            ;4F        ;4
            ret               ;C9        ;10
ClrDraw:
     ld hl,plotSScreen

     ld (StkRstr),sp
     ld de,768
     add hl,de
     ld sp,hl
     ld de,0
     ld b,192
       push de
       push de
       djnz $-2

     ld sp,(StkRstr)


;     ld d,h \ ld e,l \ inc de
;     ld bc,767
;     ld (hl),0
;     ldir
     ret
#IF $ > 4242h
.echo $-4242h," bytes to remove for the interrupt loc!"
#ENDIF
#IF $ < 4242h
.echo 4242h-$," bytes to pad for the interrupt loc!"
#ENDIF
Interrupt:             ;4242h
     push bc
     push de
     push hl
     push af
; interrupt stuff
;Note that I am using push/pop instead of the exx and ex af,af'
;instructions so that I can use shadow registers for other
;intensive routines
; Tasks to handle:
;   Sound ?
;   LCD refreshing, if a specific flag is set
;   Key ports
     
     bit forcedkey,(iy+asmflags)
     jr z,keypress
       bit keyready,(iy+asmflags2)
       jr nz,keysupdated+2
       ld hl,fkdelaycount
       ld a,(hl)
       or a
       jr z,$+12
         dec (hl)
         jr z,$+5
           xor a
           jr loadforcedkeys
         inc hl
         ld a,(hl)
         dec hl
         ld (hl),a
       dec hl
       set keyready,(iy+asmflags2)
       ;need a flag to determine if the key has been read
;HL points to fkrepeat
       ld a,(hl)
       or a
       jr z,$+9
         dec (hl)
         jr z,$+6
         dec hl
         ld a,(hl)
         jr loadforcedkeys
       ld hl,(forcedkeyptr)
       ld a,(hl)
       ;assign upper 2 bits
       ;57 to 63 can be special keys
       bit 6,a
       jr z,$+14
         and $3F
         ld de,fkrepeatkey
         ld (de),a
         inc e
         inc hl
         ldi
         jr $+3
       inc hl
       ld (forcedkeyptr),hl
       cp 63
       jr nz,$+8
         res forcedkey,(iy+asmflags)
         jr keypress+3
loadforcedkeys:
       ld (curkey),a
       ld (keydebounced),a
       jr keysupdated+2
;code for key macros
keypress:
     call GetKey
     ld hl,843Fh
     ld (hl),a
     inc l
     cp (hl)
     jr z,LoadSameKey
     ld (hl),a
     inc l
     ld (hl),32
     jp KeysUpdated
LoadSameKey:
     inc l
     dec (hl)
     jr z,ReloadKey
     xor a
     jp KeysUpdated
ReloadKey:
     ld (hl),16
KeysUpdated:     
     inc l
     ld (hl),a    ;key debounced
     bit mapmode,(iy+textflags)
     jr z,mapupdated
       ld hl,8054h
AnimUpdLoop:
       dec (hl)
       jr nz,NextAnimUpd
         inc l
         set drawmap,(iy+asmflags)
         ld bc,Tiledata
         ld e,(hl)
         ld d,0        ;DE is the tile number * 2
         ex de,hl
         inc l
         add hl,hl     ;tile data is 4 bytes, .dw loc \ .db new \ .db time
         add hl,bc
         ld a,(hl)
         add a,a
         ld (de),a
         dec e
         inc hl
         ld a,(hl)
         ld (de),a
         ex de,hl
NextAnimUpd:
       dec l
       dec l
       jp p,AnimUpdLoop
MapUpdated:
EndInterrupt:
     bit drawmap,(iy+asmflags)
     call nz,Tilemap
     bit lcdupdate,(iy+asmflags)
     call nz,UpdateLCD
     ld a,8
     out (3),a
     ld a,10
     out (3),a
     ld a,15
     out (3),a
     pop af
     pop hl
     pop de
     pop bc
     ei
     ret
RectangleBoxEraseFill:
     call RectangleOR
     inc d
     inc e
     dec b
     dec b
     dec c
     dec c
     jp RectangleXOR
RectArrowXOR:
     push de
     push bc
     ld a,b
     cp c
     jr c,$+3
       ld b,c
     ld c,1
;B is now the smaller of the two
;C is 1
     call RectangleXOR
     inc d \ inc e
     djnz $+5
     pop bc
     pop de
     ret
     djnz $-10
     jr $-5
RectangleMenu:
     call RectangleErase
     push bc \ push de
     inc e \ dec b \ dec b
     call RectangleXOR
     pop de \ pop bc
     inc d \ dec c \ dec c
     jr RectangleXOR

RectangleErase:
     call RectangleOR
RectangleXOR:
;Inputs:
;     DE is (x,y)
;     BC is (h,w)
;Outputs:
     push de
     push bc
     call RectMain
     jr nz,$+11
       ld a,c
       xor (hl)     ;logic
       ld (hl),a
       inc hl
       djnz $-4
       jp EndRect
     ld d,a        ;number of columns before last col
     ld e,b
     ld a,(rect_FirstByte)
     ld c,a
xorrectcol:
     ld b,e        ;height
     push hl
xorrectloop:
     ld a,(hl)
     xor c          ;logic
     ld (hl),a
     inc hl
     djnz xorrectloop
     pop hl
     ld c,64
     add hl,bc
     ld c,-1
     dec d
     jp m,endrect
     jr nz,xorrectcol
     ld bc,(rect_LastByte)
     jp xorrectcol
RectangleOR:
;Inputs:
;     DE is (x,y)
;     BC is (h,w)
;Outputs:
     push de
     push bc
     call RectMain
     jr nz,$+11
       ld a,c
       or (hl)     ;logic
       ld (hl),a
       inc hl
       djnz $-4
       jp EndRect
     ld d,a        ;number of columns before last col
     ld e,b
     ld a,(rect_FirstByte)
     ld c,a
orrectcol:
     ld b,e        ;height
     push hl
orrectloop:
     ld a,(hl)
     or c          ;logic
     ld (hl),a
     inc hl
     djnz orrectloop
     pop hl
     ld c,64
     add hl,bc
     ld c,-1
     dec d
     jp m,endrect
     jr nz,orrectcol
     ld bc,(rect_LastByte)
     jp orrectcol
EndRect:
     pop bc
     pop de
     ret
RectMain:
;Inputs:
;     DE is (x,y)
;     BC is (h,w)
;Outputs:
;     returns z if it is all in one column, else it returns the number of columns
;     HL points to the start byte
;     (rect_FirstByte), (rect_LastByte)
;     A is negative the number of columns
;     BC is (h,w)
;
;If it is a single column wide, C is the mask, B is the height
     ld a,d
     and %11111000
     ld h,0
     rla \ rl h
     rla \ rl h
     rla \ rl h
     ld l,a
     ld a,d
     ld d,0
     add hl,de
;HL points to the byte it will start on
     push hl
     ld d,a
     push bc
     call ComputeByte
     ld (rect_FirstByte),a
     ex (sp),hl
     ld a,d
     cpl
     and 7
     inc a
     ld b,a
     ld a,l
     sub b
     ex (sp),hl
     call ComputeByte
     cpl
     ld (rect_LastByte),a
;last and first byte are computed    
     ld a,d
     and %11111000
     ld e,a
     ld a,d
     add a,c
     and %11111000

     pop hl
     ex (sp),hl
     ld bc,(DrawBufPtr)
     add hl,bc
     pop bc

     sub e
     rrca
     rrca
     rrca
     and %00011111
     ret nz
     ld de,(rect_FirstByte)
     ld a,d \ and e
     ld c,a
     xor a
     ret
ComputeByte:
     and 7
     ld b,a
     ld a,80h
     jr z,$+5
       rrca
       djnz $-1
     add a,a
     dec a
     ret
;===============================================================
ChkFindVar:
;===============================================================
;Inputs:
;     OP1 contains the var name to search for
;Outputs:
;     A is the type
;     B is the flashpage
;     C is the name length
;     DE points to the size bytes
;     HL points to the symentry
;===============================================================
     ld de,8478h
ChkFindVarAtDE:
     ld bc,9
     ld a,(de)
     and 1Fh
     ld (de),a
     ld hl,OP2-1
     cp 5
     jr nz,$+4
     ld (hl),6
     cp 6
     jr nz,$+4
     ld (hl),5
     ex de,hl
     ld a,b
     push hl
     cpir
     jr z,$+3
       dec c
     ld a,7
     sub c
     ld (OP2-2),a
     pop hl
     rst 10h
     ld hl,(9830h)
CompareOverLoop:
     ld de,8478h
CompareLoop:
     ld bc,(982Eh)
     or a
     sbc hl,bc
     add hl,bc
     ccf
     ret z
     ld a,(de)
     ld bc,-6
     cp (hl)
     jr z,TypeMatch
     ld a,(OP2-1)
     cp (hl)
     jr z,TypeMatch
       add hl,bc
       ld c,(hl)
       inc c
       inc b
       or a
       sbc hl,bc
       jr CompareLoop
NotMatch:
   pop af
   or a
   sbc hl,bc
   jr CompareOverLoop
TypeMatch:
     add hl,bc
     push hl
     ld a,(OP2-2)
     ld c,(hl)
     dec hl
     inc b
     cp c
     jr nz,NotMatch
     inc de
CompareName:
     ld a,(de)
     inc de
     cpd
     jr nz,NotMatch
     jp pe,CompareName
FoundVar:
     pop hl
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl
     ld d,(hl)
     inc hl
     ld e,(hl)
     inc hl
     inc hl
     inc hl
     ld a,(hl)
     ret
IMenuBox:
; .db <type> ;bit 0 set means interactive
; .db y,x,h,w
; .db "header",0
; .db "option1",1
; .db "option2",1
; ,...
; .db 0
; Returns
     ld (TempWord4),a
     call WhileKey
     pop hl
     ld a,(hl)    ;type
     inc hl
     push af
     ld e,(hl)    ;y
     inc hl
     ld d,(hl)    ;x
     inc hl
     ld (TempWord1),de
     ld b,(hl)    ;h
     inc hl
     ld c,(hl)    ;w
     inc hl
     ld (TempWord2),bc
     ld (TempWord3),hl

     call RectangleMenu
     ld a,d
     add a,5
     ld (fmt_leftmost),a   ;alignment of the text
     ld (textcol),a
     dec c \ dec c
     add a,c
     ld (fmt_rightmost),a
     dec b
     ld a,e
     inc a \ inc a
     ld (fmt_upper),a
     ld (textrow),a
     add a,b
     dec a \ dec a
     ld (fmt_lower),a

     ld hl,(TempWord3)
;first disp header, if it exists
     ld a,(hl)
     inc hl
     or a
     jr z,drawbodysimple
     dec hl
     call PutTokStrFmt
     push hl
     call nextline
     ld a,(textrow)
     add a,2
     ld (textrow),a
     sub 2
     ld de,(TempWord1)
     ld e,a
     ld bc,(TempWord2)
     ld b,1
     call RectangleOR
     pop hl
drawbodysimple:
     ld de,(textcol)
     ld a,e
     ld e,d
     sub 4
     ld d,a
     ld (TempWord1),de
     call PutTokStrFmt
     pop af
     push hl        ;don't POP this, this is where PC returns to
     rrca
     ret nc
simpleMenuSelect:
;now we need to select an item
     ld de,(TempWord1)
     ld a,(TempWord4)
     ld c,a
     add a,a
     add a,c
     add a,a
     add a,e
     ld e,a
     ld bc,0505h
     call RectArrowXOR
     set lcdupdate,(iy+asmflags)
     call WaitForKey
     push af
     call RectArrowXOR
     pop af
     ld hl,(TempWord4)
     ld h,a
     cp 15
     jr nz,$+4
       ld l,-1
     dec a
     jr nz,sm_checkup
       ld a,e
       add a,6
       ld de,(fmt_lower)
       sub e
       jr nc,simpleMenuSelect
       inc l
       ld (TempWord4),hl
       jr simpleMenuSelect
sm_checkup:
     cp 3
     ld a,l
     ret nz
     dec l
     jp m,simpleMenuSelect
     jr sm_checkup-5
WaitForKey:
     halt
     call GetKeyDebounced
     or a
     jr z,$-5
     ret
WhileKey:
     halt
     call GetKeyDebounced
     or a
     jr nz,$-5
     ret
LoadSave:
     di
;set up the RAM related stuff
     ld hl,sFont
     ld (fontptr),hl
     ld hl,89F0h+asmflags
     xor a
     ld (hl),a
     inc l
     ld (hl),a
     inc l
     ld (hl),a

     ld hl,SaveFileName
     rst 20h
     call ChkFindVar
     jr nc,_gjhy
	ld hl,SaveSize
	bcall(_CreateAppVar)
	push de \ inc de \ inc de
	push bc  \ ld bc,SaveSize
	ld hl,defaultsave
	ldir
	pop bc
	pop de
_gjhy:
     ex de,hl
     inc hl
     inc hl
     ld a,b
     or a
     jr z,$+14
       ld b,0
       add hl,bc
       ld c,12
       add hl,bc
       jp p,$+6
         inc a
         ld h,40h
     push hl
     push af

;we need to allocate enough RAM for events and the save file
;1024 bytes for the main save file
;1024 bytes for one PC box open
;1024 bytes for events
;
     ld hl,3072
     bcall(42FDh)     ;enoughmem
     jp c,memerr
     ex de,hl
     ld de,saveloc
     bcall(42F7h)     ;insertmem


     pop af
     pop hl
     ld bc,SaveSize
     ld de,saveloc
     bcall(_FlashToRAM2)
     ld a,80h
     ei
     ret
memerr:
     ld a,80h
     out (16),a
     ld hl,9340h
     ld (DrawBufPtr),hl
     ld (primaryBufPtr),hl
     call ClrDraw
     bcall(42E5h)
     ex de,hl
     or a
     ld hl,3072
     sbc hl,de
     ld (TempWord5),hl
     ei
     call IMenuBox
      .db 0
      .db 14,17,36,62
      .db "Memory Error!",0
      .db "You need ",$FD
      .dw TempWord5
      .db $D6,"more bytes of",$D6,"free RAM to",$D6,"play."
      .db 0
     set lcdupdate,(iy+asmflags)
     halt
     call waitforkey
     di
     bcall(4027h)
UpdateLCD:
     ld hl,(primarybufptr)
     bit gray,(iy+asmflags)
     jr z,monochrome
     exx
     ld hl,89F0h+asmflags
     ld a,(hl)
     ld bc,$1055
     xor b
     ld (hl),a
     and b
     jr z,$+4
     rlc c

     ld de,12
     ld hl,(secondarybufptr)
     exx
     ld de,12
     ld a,20h
col3:
     out (16),a
     ex af,af'
     ld b,40h
row3:
     exx         ;4
     ld a,(hl)   ;7
     and c       ;8
     rlc c       ;8
     add hl,de   ;11
     exx         ;4
     or (hl)     ;7
     add hl,de   ;11
     bit rvideo,(iy+asmflags)  ;23
     jr z,$+3 \ cpl            ;11
     out (17),a  ;11
     djnz row3    ;13
     dec h
     dec h
     dec h
     inc hl
     exx
     dec h
     dec h
     dec h
     inc hl
     exx
     in a,(16) \ rlca \ jr c,$-3
     ex af,af'
     inc a
     cp 2Ch
     jr nz,col3
     ret


monochrome:
     bit mapmode,(iy+textflags)
     jr z,$+11
     bit mapedit,(iy+asmflags2)
     jr nz,$+5
maplcdupdate:
     ld hl,buf0
monoonelayer:
     ld a,20h
col:
     out (16),a
     inc a
     cp 2Ch
     ex af,af'
     ld bc,4011h
row:
     lcddelay()
     outi
     jr nz,row
     lcddelay()
     ex af,af'
     jr nz,col
     res lcdupdate,(iy+asmflags)
     ret

;============================================
;============================================
;Start of the game stuff
;============================================
;============================================
Continue:
     call whilekey
     call loadtestmap
     bit mapedit,(iy+asmflags2)
     jp z,moveloop-4
     

     set mapmode,(iy+textflags)


     ld hl,(mapheight)
     ld d,h
     ld e,l
     add hl,hl
     add hl,hl
     add hl,de
     inc hl
     inc hl
     inc hl
     ld (tempword3),hl



     xor a
     ld (tempword4),a     ;tile
mapeditloop:

;we swap the tiles at lfont with the ones on screen
#IF 0=1
     ld a,(tempword4)
     add a,a
     ld hl,tileunpacklut
     add a,l
     ld l,a
     jr nc,$+3 \ inc h
     ld a,(hl)
     inc hl
     ld h,(hl)
     ld l,a
     ld de,
#ENDIF



     ld hl,(mapcurptr)
     ld de,(tempword3) \ add hl,de
     ld a,(hl)
     ld de,tempword4+1
     ld (de),a    ;tilerestore

     dec e
     ld a,(de)
     ld (hl),a
     halt
     call GetKeydebounced
     or a
     jr z,$-5
     set drawmap,(iy+asmflags)
     inc e
     ex de,hl
     ldd
     inc de
     cp 15
     jp z,softreset
     cp 11
     jr nz,$+3
       dec (hl)
     cp 10
     jr nz,$+3
       inc (hl)

     cp 56
     jr nz,$+6
       ld l,0
       jr $+7     
     cp 9
     jr nz,moveedit
       ld l,(hl)
       ld bc,(mapheight)
       ld a,(yoffset)
       add a,3
       cp c
       jp nc,mapeditloop
       ld bc,(mapwidth)
       ld a,(xoffset)
       add a,5
       cp c
       jp nc,mapeditloop
       ld a,l
       ld (de),a
       jp mapeditloop
moveedit:
     cp 5
     jp nc,mapeditloop
     ld hl,(yoffset)
     ld de,(xoffset)
     exx
     ld hl,(mapheight)
     ld d,h
     ld e,l
     add hl,hl
     add hl,hl
     add hl,de
     inc hl
     inc hl
     inc hl
     ex de,hl
     ld hl,(mapcurptr)
;HL is the mapcurptr
;DE is the offset to add to test the tile
;BC is the mapheight
     dec a
     jr nz,$+5
       inc hl
       exx
       inc hl
     dec a
     jr nz,$+10
       ld bc,(mapheight)
       sbc hl,bc
       exx
       dec de
     dec a
     jr nz,$+9
       ld bc,(mapheight)
       add hl,bc
       exx
       inc de
     dec a
     jr nz,$+5
       dec hl
       exx
       dec hl
;Test if in bounds


     ld (yoffset),hl
     ld (xoffset),de
     exx
     ld (mapcurptr),hl
     jp mapeditloop













     set mapmode,(iy+textflags)
moveloop:
     ld a,(TempWord4)
     and 7Fh
     cp doortile
     call z,warp
     cp warptile
     call z,warp
     cp grass1
     call z,Battle
     cp grass2
     call z,Battle

     ld hl,playerdir
     halt
     res 6,(hl)
     call GetKeyCur
     or a
     jr z,$-7
     cp 15
     jp z,softreset
     cp 11
     jr nz,$+7
       xor a \ out (20h),a
       jr z,moveloop+3
     cp 10
     jr nz,$+10
       in a,(2)
       rlca
       sbc a,a
       out (20h),a
       jr z,moveloop+3
     cp 9
     jr nz,testgamemenu00
testtileevent:
       jr moveloop
testgamemenu00:
     res tempflag1,(iy+asmflags)
     cp 54
     jr nz,testmove
       xor a
       res mapmode,(iy+textflags)
       set drawmap,(iy+asmflags)
       halt
       res drawmap,(iy+asmflags)
       push af
       call eventshandler
       ld hl,buf0
       ld de,9340h
       ld bc,768 \ ldir
       pop af
       call IMenuBox
       .db 1,0,48,45,48,0
       .db t_Pokedex,$D6
       .db t_Pokemon,$D6
       .db "Pack",$D6
       .db $D6
       .db t_Save,$D6
       .db t_Options,$D6
       .db t_Exit,0
       ld l,a
       ld a,h
       cp 9
       jp nz,moveloop-4
       ld a,l
       or a
       jp m,moveloop-4
       push af
       call z,Pokedex
       dec a
       call z,Pokemon
       dec a
       call z,Pack
       dec a
       call z,Stats
       dec a
       call z,Save
       dec a
       call z,Options
       dec a
       jr nz,$+6
         pop af
         jp moveloop-4
       pop af
       jr testgamemenu00+9
testmove:
     cp 5
     jp nc,moveloop
     ld hl,(yoffset)
     ld de,(xoffset)
     exx
     ld hl,(mapheight)
     ld d,h
     ld e,l
     add hl,hl
     add hl,hl
     add hl,de
     inc hl
     inc hl
     inc hl
     ex de,hl
     ld hl,(mapcurptr)
;HL is the mapcurptr
;DE is the offset to add to test the tile
;BC is the mapheight
     push af
     dec a
     jr nz,$+5
       inc hl
       exx
       inc hl
     dec a
     jr nz,$+10
       ld bc,(mapheight)
       sbc hl,bc
       exx
       dec de
     dec a
     jr nz,$+9
       ld bc,(mapheight)
       add hl,bc
       exx
       inc de
     dec a
     jr nz,$+5
       dec hl
       exx
       dec hl
;Test if there is a tile in the way, or an event tile
     ld (tempword1),hl
     ld (tempword2),de
     exx
     ex de,hl
     add hl,de
     pop bc               ;b is the keypress

     ld a,(playerdir)
     ld c,a
     dec b
     ld a,b
     ld (playerdir),a
     ld a,c \ and 3
     cp b
     jp nz,moveloop
     ld a,(hl)
     ld hl,(tilepalletptr)
     add a,l
     ld l,a
     jr nc,$+3
     inc h
     ld a,(hl)
     ld (Tempword4),a
     or a
     jp p,moveloop

     inc b
     ld hl,(tempword1)
     ld (yoffset),hl
     ld hl,(tempword2)
     ld (xoffset),hl
     ld (mapcurptr),de
     set drawmapveto,(iy+asmflags2)
     ld hl,playerdir
     set 6,(hl)
     djnz scrollright

scrolldown:
     ld hl,8508h
     ld (TempWord1),hl
     ld de,(mapheight)
 ld d,0
     exx
     ld de,(xoffset)
     
     ld a,(yoffset)
     add a,7
     ld bc,(mapwidth)
     exx
     cp e
     jr c,loadtilescrolldown
       ld (hl),255
       ld de,8509h
       ld bc,95
       ldir
       ld b,4
       jp animatedownloop
loadtilescrolldown:
     ld hl,(mapcurptr)
     ld bc,7
     add hl,bc
;e' = x
;c' = width
;e  = height
;hl points to the tile
     ld b,12
loadtilescrolldownloop:
     push bc
     exx
     ld a,e
     inc e
     cp c
     exx
     push hl
     jr c,$+7
       ld hl,blacktile
       jr $+22
     ld l,(hl)
     ld h,0
     add hl,hl \ inc l
     ld de,curframe
     add hl,de
     ld e,(hl)
     ex de,hl
     add hl,hl
     ld de,tiledata
     add hl,de
     ld e,(hl)
     inc hl
     ld d,(hl)
     ex de,hl

     ld de,(TempWord1)
     ld bc,8
     ldir
     ld (TempWord1),de
     pop hl
     ld bc,(mapheight)
 ld b,0
     add hl,bc
     pop bc
     djnz loadtilescrolldownloop
     ld hl,8508h
     ld (TempWord1),hl


     ld b,4
     jp animatedownloop
scrollright:
     djnz scrollleft


     ld hl,8508h
     ld (TempWord1),hl
     ld de,(mapwidth)
 ld d,0
     exx
     ld de,(yoffset)
     
     ld a,(xoffset)
     ld bc,(mapheight)
 ld b,0
     exx
     cp e
     jr c,loadtilescrollright
       ld (hl),255
       ld de,8509h
       ld bc,63
       ldir
       jp scrollrightloop
loadtilescrollright
     ld hl,(mapcurptr)
     ld b,8
loadtilescrollrightloop:
     push bc
     exx
     ld a,e
     inc e
     cp c
     exx
     push hl
     jr c,$+7
       ld hl,blacktile
       jr $+22
     ld l,(hl)
     ld h,0
     add hl,hl \ inc l
     ld de,curframe
     add hl,de
     ld e,(hl)
     ex de,hl
     add hl,hl
     ld de,tiledata
     add hl,de
     ld e,(hl)
     inc hl
     ld d,(hl)
     ex de,hl
     ld de,(TempWord1)
     ld bc,8
     ldir
     ld (TempWord1),de
     pop hl
     inc hl
     pop bc
     djnz loadtilescrollrightloop

     ld hl,8508h
     ld (TempWord1),hl
     jp scrollrightloop
scrollleft:
     djnz scrollup
     ld hl,8508h
     ld (TempWord1),hl
     ld de,(mapwidth)
 ld d,0
     exx
     ld de,(yoffset)
     ld a,(xoffset)
     add a,11
     ld bc,(mapheight)
 ld b,0
     exx
     cp e
     jr c,loadtilescrollleft
       ld (hl),255
       ld de,8509h
       ld bc,63
       ldir
       jp scrollleftloop
loadtilescrollleft
     exx
     ld h,b \ ld l,c
;multiply by 11
     add hl,hl
     add hl,hl
     add hl,bc
     add hl,hl
     add hl,bc
     push hl
     exx
     pop bc
     ld hl,(mapcurptr)
     add hl,bc
     ld b,8
loadtilescrollleftloop:
     push bc
     exx
     ld a,e
     inc e
     cp c
     exx
     push hl
     jr c,$+7
       ld hl,blacktile
       jr $+22
     ld l,(hl)
     ld h,0
     add hl,hl \ inc l
     ld de,curframe
     add hl,de
     ld e,(hl)
     ex de,hl
     add hl,hl
     ld de,tiledata
     add hl,de
     ld e,(hl)
     inc hl
     ld d,(hl)
     ex de,hl
     ld de,(TempWord1)
     ld bc,8
     ldir
     ld (TempWord1),de
     pop hl
     inc hl
     pop bc
     djnz loadtilescrollleftloop
     jp scrollleftloop
scrollup:
     ld hl,8508h
     ld (TempWord1),hl
     ld de,(mapheight)
 ld d,0
     exx
     ld de,(xoffset)
     
     ld a,(yoffset)
     ld bc,(mapwidth)
 ld b,0
     exx
     cp e
     jr c,loadtilescrollup
       ld (hl),255
       ld de,8509h
       ld bc,95
       ldir
       jr animateuploop-8
loadtilescrollup:
     ld hl,(mapcurptr)
;e' = x
;c' = width
;e  = height
;hl points to the tile
     ld b,12
loadtilescrolluploop:
     push bc
     exx
     ld a,e
     inc e
     cp c
     exx
     push hl
     jr c,$+7
       ld hl,blacktile
       jr $+22
     ld l,(hl)
     ld h,0
     add hl,hl \ inc l
     ld de,curframe
     add hl,de
     ld e,(hl)
     ex de,hl
     add hl,hl
     ld de,tiledata
     add hl,de
     ld e,(hl)
     inc hl
     ld d,(hl)
     ex de,hl

     ld de,(TempWord1)
     ld bc,8
     ldir
     ld (TempWord1),de
     pop hl
     ld bc,(mapheight)
 ld b,0
     add hl,bc
     pop bc
     djnz loadtilescrolluploop

     ld hl,8508h+95
     ld (TempWord1),hl
     
     ld b,4
animateuploop:
     bit 1,b
     ld hl,playersprites+176
     jr nz,$+5
     ld hl,playersprites+160
     push bc
     push hl
     ld de,9340h+767
     call shiftdown2pix+3
     call shiftdown2pix
     pop hl
     exx
     ld de,buf0+344
     ld hl,9340h+344
     ld b,8
drawplayerscrollup:
     ld a,(hl)
     exx
     or (hl) \ inc hl
     xor (hl) \ inc hl
     exx
     ld (de),a
     inc de
     inc hl
     djnz drawplayerscrollup
     ldi \ ldi

     exx
     call maplcdupdate
     ld hl,(TempWord1)
     dec l \ dec l
     ld (TempWord1),hl
     pop bc
     djnz animateuploop
     res drawmapveto,(iy+asmflags2)
     bit tempflag1,(iy+asmflags)
     jp z,moveloop
     set drawmap,(iy+asmflags)
     jp moveloop

animatedownloop:
     bit 1,b
     ld hl,playersprites+32
     jr nz,$+5
     ld hl,playersprites+16    ;48*0+16
     push bc
     push hl
     ld de,9340h
     call shiftup2pix+3
     call shiftup2pix
;now we need to redraw the player sprite
;to do this, erase the two byte above it first!
     pop hl
     exx
     ld hl,9340h+342
     ld de,buf0+342
     ldi \ ldi
     ld b,8
drawplayerscrolldown:
     ld a,(hl)
     exx
     or (hl) \ inc hl
     xor (hl) \ inc hl
     exx
     ld (de),a
     inc hl \ inc de
     djnz drawplayerscrolldown
     exx
     call maplcdupdate
     ld hl,(TempWord1)
     inc l \ inc l
     ld (TempWord1),hl
     pop bc
     djnz animatedownloop
     res drawmapveto,(iy+asmflags2)
     bit tempflag1,(iy+asmflags)
     jp z,moveloop
     set drawmap,(iy+asmflags)
     jp moveloop


scrollrightloop:
     ld bc,0401h
     push bc
     call shiftright
       ld de,plotSScreen+344
       ld hl,buf0+408
       ld b,8
         ld a,(de)
         and c
         res 7,(hl)
         jr z,$+4
         set 7,(hl)
         inc hl
         inc de
         djnz $-10
     ld ix,buf0+128
     rlc c
     call shiftright
       ld de,plotSScreen+344
       ld hl,buf0+408
       ld b,8
         ld a,(de)
         and c
         res 7,(hl)
         jr z,$+4
         set 7,(hl)
         inc hl
         inc de
         djnz $-10
     rlc c
     ld a,c
     pop bc
     ld c,a
     push bc

     ld hl,playersprites+64
     bit 1,b
     jr z,$+5
     ld hl,playersprites+80
     ld de,buf0+344
     ld b,8
       ld a,(hl)
 inc hl
;       or (hl) \ inc hl
       xor (hl) \ inc hl
       ld (de),a
       inc de
       djnz $-6
;now I need to draw the sprite
;I also need to overwrite some of the shifted data with the tile data
     call maplcdupdate
     pop bc
     djnz scrollrightloop+3
     res drawmapveto,(iy+asmflags2)
     bit tempflag1,(iy+asmflags)
     jr z,$+9
     set drawmap,(iy+asmflags)
     jp moveloop
     ld hl,plotSScreen+703
     ld de,plotSScreen+767
     ld bc,704
     lddr

     ld hl,buf0
     ld de,plotSScreen
     ld bc,64
     ldir
     jp moveloop

shiftright:
;22190 max cc's needed
     ld ix,buf0+128
     ld de,(TempWord1)
     ld b,64
shiftrightloop:
     ld a,(de)
     inc e
     and c
     jr z,$+3
     scf
     rr (ix-128) \ rr (ix-64) \ rr (ix) \ rr (ix+64) \ inc ixh  ;100
     rr (ix-128) \ rr (ix-64) \ rr (ix) \ rr (ix+64) \ inc ixh   ;100
     rr (ix-128) \ rr (ix-64) \ rr (ix) \ rr (ix+64)  ;92
     dec ixh \ dec ixh \ inc ix ; 26
     djnz shiftrightloop
     ret
scrollleftloop:
     ld hl,8508h+63
     ld (TempWord1),hl
     ld bc,0480h
     push bc
     call shiftleft
       ld de,plotSScreen+344
       ld hl,buf0+280
       ld b,8
         ld a,(de)
         and c
         res 0,(hl)
         jr z,$+4
         set 0,(hl)
         inc hl
         inc de
         djnz $-10
     ld ix,buf0+128
     rrc c
     call shiftleft
       ld de,plotSScreen+344
       ld hl,buf0+280
       ld b,8
         ld a,(de)
         and c
         res 0,(hl)
         jr z,$+4
         set 0,(hl)
         inc hl
         inc de
         djnz $-10
     rrc c
     ld a,c
     pop bc
     ld c,a
     push bc

     ld hl,playersprites+112
     bit 1,b
     jr z,$+5
     ld hl,playersprites+128
     ld de,buf0+344
     ld b,8
       ld a,(hl)
       inc hl
       xor (hl) \ inc hl
       ld (de),a
       inc de
       djnz $-6
;now I need to draw the sprite
;I also need to overwrite some of the shifted data with the tile data
     call maplcdupdate
     pop bc
     djnz scrollleftloop+9
     res drawmapveto,(iy+asmflags2)
     bit tempflag1,(iy+asmflags)
     jr z,$+9
     set drawmap,(iy+asmflags)
     jp moveloop
     ld de,plotSScreen
     ld hl,plotSScreen+64
     ld bc,704
     ldir

     ld hl,buf0+704
     ld de,plotSScreen+704
     ld bc,64
     ldir
     jp moveloop

shiftleft:
;22190 max cc's needed
     ld ix,buf0+768-65
     ld de,(TempWord1)
     ld b,64
shiftleftloop:
     ld a,(de)
     dec e
     and c
     jr z,$+3
     scf
     rl (ix+64) \ rl (ix) \ rl (ix-64) \ rl (ix-128) \ dec ixh  ;100
     rl (ix+64) \ rl (ix) \ rl (ix-64) \ rl (ix-128) \ dec ixh  ;100
     rl (ix+64) \ rl (ix) \ rl (ix-64) \ rl (ix-128)  ;92
     inc ixh \ inc ixh \ dec ix ; 26
     djnz shiftleftloop
     ret

shiftdown2pix:
;17250 t-states
     ld de,buf0+767
     ld h,d \ ld l,e \ dec l \ dec l
     exx
     ld hl,(tempword1)     ;points into textshadow, where the new tile data is located
     ld b,0
     exx
     ld a,12 \ ld b,0
shiftdown2loop:
     ld c,62
     lddr

     push de
     exx
     pop de
     ld bc,-4
     ldd \ ldd
     add hl,bc
     push de
     exx
     pop de
     dec hl
     dec hl
     dec a
     jr nz,shiftdown2loop
     ret

shiftup2pix:
     ld de,buf0
     ld h,d \ ld l,e \ inc l \ inc l
     exx
     ld hl,(tempword1)     ;points into textshadow, where the new tile data is located
     ld b,0
     exx
     ld a,12 \ ld b,0
shiftup2loop:
     ld c,62
     ldir
     push de
     exx
     pop de
     ld c,8
     ldi \ ldi
     add hl,bc
     push de
     exx
     pop de
     inc l
     inc hl
     dec a
     jr nz,shiftup2loop
     ret
warp:
Battle:
     ret
Load:
New:
     jp softreset
     xor a
Options:
     call IMenuBox
      .db 1
      .db 2,2,23,39+36
      .db t_Options,0
      option("Text Speed:",textspd,t_slow)
      item(t_exit)
      .db 0
     or a
     jp m,opt_opt1
     jr nz,opt_opt1
       ld a,h
       ld hl,(textspd)
       cp 3
       jr nz,$+13
         inc l
         ld a,l
         cp 3
         jr z,Options-1
         ld (textspd),hl
         jr Options-1
       cp 2
       jr nz,$+8
         dec l
         jp m,Options-1
         jr $-13
opt_opt1:         
     ld a,3
     ret
Tilemap:
     res drawmap,(iy+asmflags)
     bit drawmapveto,(iy+asmflags2)
     jr z,$+7
       set tempflag1,(iy+asmflags)
       ret
     ld (interruptStkRstr),sp
     ld hl,(xoffset)
     ld (xcur),hl
     ld hl,(mapcurptr)
     ld (tileptr),hl
     ld hl,(DrawBufPtr)
     ld (curdrawptr),hl
     xor a
     ld (x),a
xloop:
     xor a
     ld (y),a
     ld hl,(yoffset)
     ld (ycur),hl

     ld hl,(xcur)
     ld bc,(mapwidth)
     sbc hl,bc
     jr c,yloop
       ld hl,(curdrawptr)
       ld bc,64
       add hl,bc
       ld sp,hl
       ld (curdrawptr),hl
       ld hl,-1
       ld b,4
         push hl
         push hl
         push hl
         push hl
         push hl
         push hl
         push hl
         push hl
         djnz $-8   ;399 tstates for this loop, down from 1659

     ld hl,(tileptr)
     ld bc,(mapheight)
     add hl,bc
     ld (tileptr),hl
     jr nextcol


yloop:
     ld hl,(ycur)
     ld bc,(mapheight)
     or a
     sbc hl,bc
     jr c,loadtile
       ld hl,(curdrawptr)
       ld bc,8
       add hl,bc
       ld (curdrawptr),hl
       ld sp,hl
       ld hl,-1
       push hl
       push hl
       push hl
       push hl
       jr tiledrawn
loadtile:
     ld hl,(tileptr)
     ld l,(hl)
     ld h,0
     add hl,hl \ inc l
;     ld de,curframe
;     add hl,de
;     ld e,(hl)
;     ex de,hl
	ld h,80h \ ld l,(hl)

     add hl,hl     ;oh, this works because H = 80, otherwise we need to set H to 0 at this point
     ld de,tiledata
     add hl,de
     ld sp,hl
     pop de
drawtile:
     ld hl,(curdrawptr)
     ex de,hl
     ldi
     ldi
     ldi
     ldi
     ldi
     ldi
     ldi
     ldi
     ld (curdrawptr),de
tiledrawn:

     ld sp,tileptr
     pop hl \ inc hl \ push hl
     ld sp,ycur
     pop hl \ inc hl \ push hl

     ld a,(y)
     inc a
     ld (y),a
     cp 8
     jp nz,yloop


     ld sp,adjust
     pop bc
     pop hl
     add hl,bc
     push hl
nextcol:
     ld sp,xcur
     pop hl \ inc hl \ push hl
     ld a,(x)
     inc a
     ld (x),a
     cp 12
     jp nz,xloop
     ld sp,(interruptStkRstr)

     call EventsHandler
     set lcdupdate,(iy+asmflags)   ;we could just have the code itself here...
     ret

IGPutSFmt:
     pop hl
     call GPutSFmt
     jp (hl)
PutTokStrFmt:
;Inputs:
;     HL points to the token string to display
;Special Tokens:
;     FBxxxx - Display a string
;     FCxxxx - Display a 32-bit number
;     FDxxxx - Display a 16-bit number
;     FExxxx - Display an 8-bit number
;     FFxxxxyy - Display a token based on a byte + offset
     ld a,(hl)
     inc hl
     or a
     ret z
     cp $FF
     jr nz,TestPutNum
       ld e,(hl)
       inc hl
       ld d,(hl)
       inc hl
       ld a,(de)
       add a,(hl)
       inc hl
       jr disptokstr
TestPutNum:
     cp $FE
     jr nz,TestPutNum16
       ld e,(hl)
       inc hl
       ld d,(hl)
       inc hl
       push hl
       ld a,(de)
       ld e,a \ ld d,0
       jr dispnumstr16
TestPutNum16:
     cp $FD
     jr nz,TestPutNum32
       ld e,(hl)
       inc hl
       ld d,(hl)
       inc hl
       push hl
       ex de,hl
       ld e,(hl)
       inc hl
       ld d,(hl)
dispnumstr16:
       ld bc,0
       jr dispnum32
TestPutNum32:
     cp $FC
     jr nz,TestPutStr
       ld e,(hl)
       inc hl
       ld d,(hl)
       inc hl
       push hl
       ex de,hl
       ld e,(hl)
       inc hl
       ld d,(hl)
       inc hl
       ld c,(hl)
       inc hl
       ld b,(hl)
DispNum32:
;BCDE is the number to display
;10 bytes needed
       ld hl,OP1+9
       xor a
       exx \ ld c,10 \ exx
       ld (hl),a
         dec l
         call BCDE_div_C
         add a,30h
         ld (hl),a
         ld a,b \ or c \ or d \ or e
         jr nz,$-11
       call GPutSFmt
       pop hl
       jr PutTokStrFmt
TestPutStr:
     cp $FB
     jr nz,disptokstr
       ld e,(hl)
       inc hl
       ld d,(hl)
       inc hl
       push hl
       ex de,hl
       call PutTokStrFmt
       pop hl
       jr PutTokStrFmt
disptokstr:
     push hl
     cp 20h
     jr z,PutASCIIFmt
     cp '.'
     jr z,PutASCIIFmt
     cp ','
     jr z,PutASCIIFmt
     cp ':'
     jr z,PutASCIIFmt
     cp '!'
     jr z,PutASCIIFmt
     cp '?'
     jr z,PutASCIIFmt
     cp $D6
     jr z,PutASCIIFmt
     ld hl,tokenLUT-2
     cp 30h
     jr c,_00to30
     cp 3Ah
     jr c,PutASCIIFmt
     cp 41h
     jr c,_3Ato40
     cp 5Bh
     jr c,PutASCIIFmt
     cp 61h
     jr c,_5Bto61
     cp 7Bh
     jr c,PutASCIIFmt
     sub 26
_5Bto61:
     sub 26
_3Ato40:
     sub 10
_00to30:
     add a,a
     jr nc,$+3
     inc h
     add a,l
     ld l,a
     jr nc,$+3
     inc h
     ld e,(hl)
     inc hl
     ld d,(hl)
     ex de,hl
     call GPutSFmt
     pop hl
     jp PutTokStrFmt
PutASCIIFmt:
     call GPutCFmt
     jr $-7
GPutSFmt:
;Inputs:
;     HL points to the zero-terminated string to display
;     (fmt_indent)
;     (fmt_leftmost)
;     (fmt_rightmost)
;     (fmt_lower)
;     (fmt_upper)
;     bit textinverse,(iy+textflags)
;     bit wordwrap,(iy+textflags)
;     (fontset)
;     (newlineinc)
     ld a,(hl)
     inc hl
     or a
     ret z
     push de
     push hl
     call GPutCFmt
     pop hl
     pop de
     jr GPutSFmt
BCDE_Div_C:
     push hl
     ex de,hl
     exx \ ld a,c \ exx
     ld d,32
     ld e,a
     xor a
div32loop:
     add hl,hl
     rl c \ rl b
     rla
     cp e
     jr c,$+4
       sub e \ inc l
     dec d
     jr nz,div32loop
     ex de,hl
     pop hl
     ret
GPutCFmt:
;Input:
;     A is the char to display
     ld b,a
     call GPutC
;perform formatting based on indents, wordwrap
;     bit wordwrap,(iy+textflags)
;     ret z
     ld hl,(textcol)
     ld de,(fmt_rightmost)
     ld a,e
     sub l
     ret nc
     ld a,d
     sub h
     ret c
     ld a,(fmt_leftmost)
     ld l,a
     ld a,6
     add a,h
     ld h,a
     ld (textcol),hl
     ret
GPutC:
;Inputs:
;     (fontptr)
;     (textcol)
;     (textrow)
;     B is the char to display
     ld a,$D6
     cp b
     jr nz,charreg
nextline:
       ld a,(fmt_leftmost)
       ld (textcol),a
       ld a,(textrow)
       add a,6
       ld (textrow),a
       ret
charreg:
     ld hl,(fontptr)
VPutSC:
;Inputs:
;    B is the char to draw
     ld a,b
     ld c,b
     ld b,0
     add hl,bc
     add hl,bc
     add hl,bc
     ld de,lfont_record
     ld b,3
       ld a,(hl)
       and $F0
       ld (de),a
       inc e
       ld a,(hl)
       rrca \ rrca
       rrca \ rrca
       and $F0
       ld (de),a
       inc e
       inc hl
       djnz $-15
     ld ix,lfont_record

VputSCStepin:
;4973h
     ld de,0406h
     ld bc,(textcol)
     ld hl,fmt_lower
     ld a,b
     cp (hl) \ ret nc
;e is height
     add a,e
     sub (hl)
     jr c,$+6
       neg
       add a,e
       ld e,a

     ld a,c
     dec l
     cp (hl) \ ret nc


     ld a,c
     add a,4
     ld (textcol),a
     ld a,b
     ld b,c
     ld c,a
ORSprite8xY:
;Note: No clipping.
;Inputs:
;     BC = (x,y)
;     IX points to the sprite
;     E is the height
     ld a,b
     and $F8
     ld h,0
     rla \ rl h
     rla \ rl h
     rla \ rl h
     ld l,a
     ld a,b
     ld b,0
     add hl,bc
     ld bc,(DrawBufPtr)
     add hl,bc
;HL points to the first byte to draw at
     and 7
     jr nz,crossedbound
       ld b,e
       push ix \ pop de
         ld a,(de)
         xor (hl)
         ld (hl),a
         inc hl
         inc de
         djnz $-5
       ret
crossedbound:
     ld b,a
     ld d,a
     ld a,1
       rrca
       djnz $-1
     dec a
     ld c,e
     push bc
     ld e,a
;E is the mask
;IX points to the sprite
;HL points to where to draw
drawloop1:
     ld a,(ix)
     ld b,d \ rrca \ djnz $-1
     and e
     or (hl)
     ld (hl),a
     inc ix
     inc hl
     dec c
     jr nz,drawloop1
     ld c,64
     add hl,bc
     ld a,e
     cpl
     ld e,a
     pop bc
drawloop2:
     dec ix
     dec hl
     ld a,(ix)
     ld b,d \ rrca \ djnz $-1
     and e
     or (hl)
     ld (hl),a
     dec c
     jr nz,drawloop2
     ret

DispMain:
     res drawmap,(iy+asmflags)
     res mapmode,(iy+textflags)
     call ClrDraw
     push af
     call IMenuBox
       .db 0
       .db 55,0,9,96
       .db 0
       .db $FB \ .dw playername \ .db $D6     ;player name
       .db 0
     pop af
     call IMenuBox
       .db 1
       .db 0,0,33,39
       .db 0
       .db "Continue",$D6
       .db "Load",$D6
       .db "New",$D6
       .db t_Options,$D6
       .db t_Exit
       .db 0
     ret
DE_Times_BC:
;Inputs:
;     DE and BC are factors
;Outputs:
;     A,D,E are 0
;     BC is not changed
;     HL is the product
;870 cycles, worst case :)
     ld hl,0
     ld a,8
Mul_Loop_1:
     add hl,hl
     rl e \ rl d
     jr nc,$+3
       add hl,bc
     add hl,hl
     rl e \ rl d
     jr nc,$+3
       add hl,bc
     dec a
     jr nz,Mul_Loop_1
     ret
H_Times_E:
;Inputs:
;     H,E
;Outputs:
;     HL is the product
;     D,B are 0
;     A,E,C are preserved
;Size:  36 bytes
;Speed: 191+6b+9p, b is the number of bits set in the input H, p is if it is odd
;       -1 if negative
;   average is 229.5 cycles (105.5 cycles saved)
;   max required is 258 cycles (101 cycles saved)
     ld d,0      ;1600   7   7
     ld l,d      ;6A     4   4
           ;      
     sla h       ;CB24  8
     jr nc,$+3   ;3001  12-1b
     ld l,e      ;6B    --

     add hl,hl   ;29    11
     jr nc,$+3   ;3001  12+6b
     add hl,de   ;19    --

     add hl,hl   ;29    11
     jr nc,$+3   ;3001  12+6b
     add hl,de   ;19    --

     add hl,hl   ;29    11
     jr nc,$+3   ;3001  12+6b
     add hl,de   ;19    --

     add hl,hl   ;29    11
     jr nc,$+3   ;3001  12+6b
     add hl,de   ;19    --

     add hl,hl   ;29    11
     jr nc,$+3   ;3001  12+6b
     add hl,de   ;19    --

     add hl,hl   ;29    11
     jr nc,$+3   ;3001  12+6b
     add hl,de   ;19    --

     add hl,hl   ;29   11
     ret nc      ;D0   11+15p
     add hl,de   ;19   --
     ret         ;C9   --
EventsHandler:
  bit mapedit,(iy+asmflags2)
  ret nz
     ld de,buf0
     ld hl,9340h
     ld bc,768
     ldir
;now draw the player sprite
     ld a,(playerdir)
     ld b,a
     ld a,(curkey) \ or a
     ld a,b
     jr nz,$+7
       and 3
       ld (playerdir),a
     ld hl,playersprites
     and 3
     ld c,a
     add a,a
     add a,c
     add a,a
     add a,a
     add a,a
     add a,a
     add a,l
     ld l,a
     jr nc,$+3
     inc h
     ld a,b
     and 48
     add a,l
     ld l,a
     jr nc,$+3
     inc h
     ;HL points to the sprite
     ld de,buf0+344
     ld b,8
copyplayerloop:
     ld a,(de)
     or (hl) \ inc hl
     xor (hl) \ inc hl
     ld (de),a \ inc de
     djnz copyplayerloop
     ret
       
;now we check the event table
     ld hl,EventTable
EventTableLoop:
     ld a,(hl)
     inc hl
     or a
     jr z,EventEnd
     dec a
     jr nz,CheckTree
       ;npc code.
CheckTree:
     dec a
     jr nz,CheckBould
       ;tree code
CheckBould:
     dec a
     jr nz,CheckWarp
       ;Boulder code
CheckWarp:
     dec a
     jr nz,CheckDoor
       ;Warp Tile code
CheckDoor:
     dec a
     jr nz,EventTableLoop
       ; code
       jr EventTableLoop
EventEnd:
;HL points to where it gets drawn
;DE is the sprite layer
     ld bc,12
     ld a,8
       ex de,hl   ; 32
       ldi        ;128
       ex de,hl   ; 32
       add hl,bc  ; 88
       inc c      ; 32
       dec a      ; 32
       jr nz,$-7  ; 91
     ret
Pokedex:
     ld de,0
     ld bc,$1A1A
     call RectangleOR
     dec c \ dec b
     call RectangleOR
     ld hl,pokedexinfo-1
     ld de,$01FF
     ld (TempWord1),de
Pokedexloop:
     ld de,(TempWord1)
     dec a
     jr nz,checkpokedexup
       inc e
       ld a,e
       cp 64
       jr z,drawentry
       rrc d
       jr c,$+3
       inc hl
       ld a,(hl)
       and d
       jr z,$-13
       ld (TempWord1),de
       jr z,drawentry
checkpokedexup:
     dec e
     ld a,e
     jp m,drawentry
     rlc d
     jr c,$+3
     dec hl
     ld a,(hl)
     and d
     jr z,$-12
     ld (TempWord1),de
drawentry:
     ld de,(TempWord1)
     ld a,e
     or a
     jp m,noPokedexdata
     ld d,0
     ex de,hl
     add hl,hl
     push hl
     ld de,(PokemonSpriteLUT)
     add hl,de
     ld e,(hl)
     inc hl
     ld d,(hl)
;DE points to the sprite
     call DrawPokemon-3
     pop de
     ld hl,(PokedexInfoLUT)
     add hl,de
     ld e,(hl)
     inc hl
     ld d,(hl)
;DE points to the compressed text
     call DrawTextBox
pokedexwait:
     call GetKeyDebounced
     or a \ jr z,pokedexwait
     cp 1 \ jr z,Pokedexloop
     cp 4 \ jr z,Pokedexloop
     jr pokedexwait
noPokedexdata:
     ret

Pokemon:
Pack:
Stats:
     xor a
     ret
Save:
     xor a
     ret
DrawTextBox:
;DE points to the text
     push de
     pop de
     ret


     ld bc,0
DrawPokemon:
;BC = (x,y)
;DE points to the sprite
     ld a,b
     and 7
     jr z,DrawPokemonFast
     push de
     pop ix
     ld de,$0318
DrawPokemonLoop:
     push de
     push bc
     call ORSprite8xY
     pop bc
     ld a,b
     add a,8
     ld b,a
     pop de
     dec d
     jr nz,DrawPokemonLoop
     ret
DrawPokemonFast:
     ld h,a
     ld l,b
     ld b,h
     add hl,hl
     add hl,hl
     add hl,hl
     add hl,bc
     ex de,hl
     ld a,3

     ld c,24
     ldir
     ld c,40
     ex de,hl
     add hl,bc
     ex de,hl
     dec a
     jr nz,$-10
     ret


GetKeyDebounced:
     ld a,(keydebounced)
     res keyready,(iy+asmflags2)
     ret
GetKeycur:
     ld a,(curkey)
     res keyready,(iy+asmflags2)
     ret


playersprites:
 .db $3E,$00,$7F,$3E,$7F,$00,$7F,2Ah,$7F,$3E,$3E,$00,$7F,$22,$36,$00
 .db $3E,$00,$7F,$3E,$7F,$00,$7F,2Ah,$7F,$1E,$7F,$20,$7F,$00,$36,$00
 .db $3E,$00,$7F,$3E,$7F,$00,$7F,2Ah,$7F,$3C,$7F,$02,$7F,$00,$36,$00

 .db $3C,$00,$7E,$3C,$7F,$00,$7F,$2A,$7F,$3C,$3D,$00,$1C,$08,$3C,$00
 .db $3C,$00,$7E,$3C,$7F,$00,$7F,$2A,$7F,$3C,$3D,$02,$3E,$10,$7E,$00
 .db $3C,$00,$7E,$3C,$7F,$00,$7F,$2A,$7F,$3C,$3D,$02,$3E,$04,$7E,$00

 .db $1E,$00,$3F,$1E,$7F,$00,$7F,$2A,$7F,$1E,$5E,$00,$1C,$08,$1E,$00
 .db $1E,$00,$3F,$1E,$7F,$00,$7F,$2A,$7F,$1E,$5E,$00,$3E,$04,$3F,$00
 .db $1E,$00,$3F,$1E,$7F,$00,$7F,$2A,$7F,$1E,$5E,$00,$3E,$10,$3F,$00


 .db $3E,$00,$7F,$3E,$7F,$00,$7F,$2A,$7F,$2A,$3E,$08,$7F,$22,$36,$00
 .db $3E,$00,$7F,$3E,$7F,$00,$7F,$2A,$7F,$28,$7F,$0A,$7F,$30,$36,$00
 .db $3E,$00,$7F,$3E,$7F,$00,$7F,$2A,$7F,$0A,$7F,$28,$7F,$06,$36,$00


MainScreen:
.option bm_map = 12x1
.option bm_min_w = 8
.option bm_shd = 2
#include "omnirpg\omnirpg.bmp"


sFont:
;===============================================================
FontSet:
;===============================================================
;00~7F
.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$8C,$EC,$80,$00,$00,$00,$00,$00,$00
.db $24,$44,$20,$0A,$4A,$00,$00,$EA,$E0,$00,$4E,$40,$00,$04,$00,$00,$E4,$44,$E4,$2C,$00,$EC,$EC,$C0

.db $74,$4C,$40,$62,$A2,$00,$C2,$4E,$00,$02,$48,$E0,$69,$96,$00,$AC,$88,$00,$E4,$40,$00,$68,$60,$E0
.db $2E,$4E,$80,$C2,$C0,$E0,$06,$00,$00,$E8,$C8,$E0,$42,$F2,$40,$AD,$DD,$A0,$4E,$44,$40,$44,$4E,$40

.db $00,$00,$00,$44,$40,$40,$AA,$A0,$00,$00,$00,$00,$00,$00,$00,$A2,$48,$A0,$4A,$4A,$50,$88,$80,$00
.db $24,$44,$20,$84,$44,$80,$00,$40,$00,$04,$E4,$00,$00,$44,$80,$00,$E0,$00,$00,$00,$80,$22,$48,$80

;FontNumbers
.db $4A,$AA,$40,$4C,$44,$E0,$C2,$48,$E0,$C2,$42,$C0,$AA,$E2,$20,$E8,$C2,$C0,$68,$EA,$E0,$E2,$44,$40,$EA,$EA,$E0,$EA,$E2,$20

;3Ah~3Fh
.db $04,$04,$00,$04,$04,$80,$24,$84,$20,$0E,$0E,$00,$84,$24,$80,$C2,$40,$40

.db $00,$00,$00,$4A,$EA,$A0,$CA,$CA,$C0,$68,$88,$60,$CA,$AA,$C0,$E8,$C8,$E0,$E8,$C8,$80,$68,$AA,$60
.db $AA,$EA,$A0,$E4,$44,$E0,$62,$2A,$40,$AA,$CA,$A0,$88,$88,$E0,$AE,$AA,$A0,$CA,$AA,$A0,$EA,$AA,$E0
.db $CA,$C8,$80,$EA,$AE,$60,$CA,$CA,$A0,$68,$42,$C0,$E4,$44,$40,$AA,$AA,$E0,$AA,$AA,$40,$AA,$AE,$A0
.db $AA,$4A,$A0,$AA,$44,$40,$E2,$48,$E0,$4A,$EA,$40,$88,$42,$20,$C4,$44,$C0,$4A,$00,$00,$00,$00,$E0
.db $84,$00,$00,$06,$AA,$60,$88,$CA,$C0,$06,$88,$60,$22,$6A,$60,$04,$AC,$60,$48,$C8,$80,$06,$A6,$2C
.db $88,$CA,$A0,$40,$44,$40,$20,$22,$A4,$8A,$CA,$A0,$88,$88,$40,$0A,$EA,$A0,$0C,$AA,$A0,$04,$AA,$40
.db $0C,$AC,$80,$06,$A6,$22,$0A,$C8,$80,$0C,$84,$C0,$4E,$44,$20,$0A,$AA,$E0,$0A,$AA,$40,$0A,$AE,$A0
.db $0A,$44,$A0,$0A,$A6,$24,$0E,$24,$E0,$64,$84,$60,$44,$44,$40,$C4,$24,$C0,$05,$A0,$00,$E0,$E0,$E0

;FontNumbers2
.db $04,$AA,$A4,$04,$C4,$4E,$0C,$24,$8E,$0C,$24,$2C,$0A,$AE,$22,$0E,$8C,$2C,$06,$8E,$AE,$0E,$24,$44
.db $0E,$AE,$AE,$0E,$AE,$22

;Accented A
.db $24,$AE,$A0,$84,$AE,$A0,$00,$00,$00,$A4,$AE,$A0

;Accented a
.db $24,$06,$A5,$42,$06,$A5,$4A,$06,$A5,$A0,$6A,$60

;Accented E
.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00

;Accented e
.db $48,$4A,$C6,$42,$4A,$C6,$4A,$4A,$C6,$A0,$4A,$C6

;Accented I
.db $24,$0E,$4E,$84,$0E,$4E,$4A,$0E,$4E,$A0,$E4,$E0

;Accented i
.db $24,$04,$44,$84,$04,$44,$4A,$04,$44,$A0,$44,$40

;Bombs... er, accented O
.db $24,$69,$96,$84,$69,$96,$4A,$69,$96,$A0,$69,$96

;Lowercase bombs
.db $24,$06,$96,$84,$06,$96,$4A,$06,$96,$A0,$06,$96

;Accented U
.db $24,$AA,$A6,$84,$AA,$A6,$4A,$AA,$A6,$A0,$AA,$A6

;Accented u
.db $24,$0A,$A6,$84,$0A,$A6,$4A,$0A,$A6,$A0,$0A,$A6

;Accented C,c,N,n
.db $4A,$8A,$48,$06,$88,$6C,$5A,$0C,$AA,$5A,$0C,$AA

;Other Puntuation
.db $24,$00,$00,$84,$00,$00,$A0,$00,$00,$40,$48,$60

;Upside-Down Exclamation Point Identical to lowercase i
;Change to something else?
.db $00,$00,$00

;Greek
.db $05,$AA,$50,$25,$65,$A0,$05,$A2,$20,$00,$4A,$E0,$34,$27,$96,$68,$E8,$60

;[
.db $64,$44,$60

;Greek (continued)
.db $84,$25,$90,$0A,$AD,$80,$0F,$55,$90,$25,$56,$48,$F4,$24,$F0
.db $07,$55,$40,$07,$A2,$10
;Idunno howta do these
.db $4E,$AE,$40,$69,$99,$69

;CC~CF
.db $E0,$A4,$A0,$E0,$A6,$24,$52,$50,$00,$00,$00,$A0,$26,$E6,$20

;D0~D5
.db $44,$40,$00,$22,$48,$80,$00,$60,$00,$C4,$8C,$00,$EA,$E0,$00,$E4,$2C,$00

;D6
.db $00,$00,$00

;D7~DF
.db $40,$44,$20,$04,$CA,$C8,$8A,$4A,$20,$E9,$AE,$A8,$69,$E8,$60,$00,$44,$60,$9D,$FB,$90,$A5,$55,$A0,$4E,$FE,$40

;Overwrite Cursor
.db $FF,$FF,$FF,$FB,$1B,$BF,$FB,$51,$5F,$FF,$95,$9F

;Insert Cursor
.db $00,$00,$0F,$4E,$EE,$0F,$4A,$EA,$0F,$06,$A6,$0F

;E8~EF
.db $00,$84,$20,$00,$C6,$20,$00,$E6,$20,$00,$8C,$E0,$25,$D5,$20,$4A,$AA,$40,$4E,$44,$40

;F0~F4
.db $44,$4E,$40,$5A,$5A,$5A,$27,$A6,$3E,$4E,$44,$00,$69,$A9,$A0

;male/female
.db $73,$5E,$AE,$EA,$E4,$E4

;BlockEater Down	$F7
.db $6F,$96,$90
;BlockEater Left        $F8
.db $6F,$16,$90
;BlockEater Right       $F9
.db $6F,$86,$90
;BlockEater Up          $FA
.db $69,$96,$90

;FB~FE
.db $09,$AC,$E0,$08,$53,$70,$EC,$A1,$00,$73,$58,$00

;FF
.db $A5,$A5,$A5
TokenLUT:
 .dw s_newline
 .dw s_The
 .dw s_If
 .dw s_Hello
 .dw s_Hi
 .dw s_thelow
 .dw s_game
 .dw s_and
 .dw s_exclam
 .dw s_period
 .dw s_comma
 .dw s_question
 .dw s_Options
 .dw s_Exit
 .dw s_slow
 .dw s_normal
 .dw s_fast
 .dw s_Pokedex
 .dw s_Pokemon
 .dw s_Save
s_slow:
 .db "slow",0
s_normal:
 .db "normal",0
s_fast:
 .db "fast",0
s_Options:
 .db "Options",0
s_Exit:
 .db "Exit",0
s_newline:
 .db $D6,0
s_exclam:
 .db "!",0
s_period:
 .db ".",0
s_comma:
 .db ",",0
s_question:
 .db "? ",0
s_The:
 .db "The ",0
s_If:
 .db "If ",0
s_Hello:
 .db "Hello",0
s_Hi:
 .db "Hi",0
s_game:
 .db " game",0
s_thelow:
 .db " the ",0
s_and:
 .db " and ",0
s_Pokedex:
 .db "Pok",$96,"dex",0
s_Pokemon:
 .db "Pok",$96,"mon",0
s_Save:
 .db "Save",0

testmap: ;23 wide, 13 tall
 .db 1
 .db 23     ;height
 .db 23     ;width
 .db -3     ;xoffset
 .db 0      ;yoffset
 .db 41     ;tile pallet size
 .db 128,128+1,128+2,3,4,5,6,7,8,9,10,11,128+12,13,14,15,16,17,18,19,20,21,22,23,24,25,26 ;tile pallet
   .db 27,28,29,30,31,32,33,128+34,35,36,37,38,39,40
 .dw -69      ;xoffset*height+yoffset
 .db 3,16,17,16,17,16,17,16,17,16,17,16,17, 16,17,16,17,16,17,16,17,16,17
 .db 16,17,16,17,16,17,16,17,16,17,16,17, 16,17,16,17,16,17,16,17,16,17,3
 .db 3,6,11,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,23,24,19,20,3
 .db 3,7,12,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,25,26,21,22,3
 .db 3,7,14,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,23,24,23,24,3
 .db 3,8,13,0,0,0,0,2,0,0,0,0, 0,0,0,0,0,0,25,26,25,26,3
 .db 3,0,1,1,1,0,0,2,2,0,0,0, 0,0,0,0,0,0,23,24,23,24,3
 .db 3,0,1,1,1,0,0,2,2,2,0,0, 0,0,0,0,0,0,25,26,25,26,3
 .db 3,0,1,1,1,0,0,2,2,2,2,0, 0,0,0,0,0,0,0,0,0,0,3
 .db 3,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,3
 .db 3,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,3
 .db 3,0,0,0,5,5,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,3
 .db 3,0,0,0,5,5,5,5,5,0,0,0, 0,0,0,0,0,0,0,0,0,0,3
 .db 3,0,0,0,0,5,5,5,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,3
 .db 3,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,3
 .db 3,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,3
 .db 3,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,3
 .db 3,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,3
 .db 3,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,3
 .db 3,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,3
 .db 3,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,3
 .db 3,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,3
 .db 3,3,3,3,3,3,3,3,3,3,3,3, 3,3,3,3,3,3,3,3,3,3,3
testmapend:

testmapname:
     .db 15h,"ORPGMap",0
loadtestmap:
     di
     ld hl,testmapname
     rst 20h
     call ChkFindVar
     jr nc,$+19
       ld hl,testmapend-testmap
       bcall(_CreateAppVar)
       push de \ inc de \ inc de
       push bc
       ld hl,testmap
       ldir \ pop bc \ pop de
     ei
     ex de,hl
     inc hl \ inc hl
     ld de,curframe
     ld b,e
     ld a,(hl)
     inc hl
     or a
     jr z,$+6
       set mapedit,(iy+asmflags2)
     ld a,(hl)
     inc hl
     ld c,a
     ld (mapheight),bc
     sub 8
     jr nc,$+3
       dec b
     ld c,a
     ld (adjust),bc
     ld b,0

     ld c,(hl)
     inc hl
     ld (mapwidth),bc
     ld c,(hl)
     inc hl
	ld a,c \ add a,a \ sbc a,a \ ld b,a
     ld (xoffset),bc
     ld (xmapcoord),bc
     ld c,(hl)
     inc hl
	ld a,c \ add a,a \ sbc a,a \ ld b,a
     ld (yoffset),bc
     ld (ymapcoord),bc

     ld b,(hl)
     inc hl
     ld (tilepalletptr),hl
     ld c,1
     ex de,hl

     inc b \ dec b \ jr z,$+11

       ld (hl),c \ inc l
       ld a,(de) \ add a,a
       ld (hl),a \ inc l
       inc de
       djnz $-7
     ex de,hl
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl
     ld (tilemapdata),hl
     add hl,bc
     ld (mapcurptr),hl
     ret


TileData:                ; .dw ptr \ .db (evolve-TileData)/4,dur
tile_blank:    addtile(blank,   tile_blank,   0)
tile_flower1:  addtile(flower1, tile_flower2, 128)
tile_grass:    addtile(grass,   tile_grass,   0)
tile_bush:     addtile(bush,    tile_bush,    0)     ;a small tree (8x8)
tile_vine:     addtile(vine,    tile_vine,    0)     ;instead of that silly tree to cut down
tile_water1:   addtile(water1,  tile_water2,  128)
tile_roofleft: addtile(roofleft,tile_roofleft,0)
tile_roofmid:  addtile(roofmid, tile_roofmid, 0)
tile_roofrgt:  addtile(roofrgt, tile_roofrgt, 0)
tile_poklft:   addtile(poklft,  tile_poklft,  0)
tile_pokrgt:   addtile(pokrgt,  tile_pokrgt,  0)
tile_pokll:    addtile(pokll,   tile_pokll,   0)
tile_poklm:    addtile(poklm,   tile_poklm,   0)
doortile = (tile_poklm-TileData)/4
grass1   = (tile_grass-TileData)/4
grass2   = 255
warptile = 255
tile_poklr:    addtile(poklr,   tile_poklr,   0)
tile_pokheal1: addtile(pokheal1,tile_pokheal2,0)
tile_pokmerc:  addtile(pokmerc, tile_pokmerc, 0)
tile_treest:   addtile(treest,  tile_treest,  0)     ;skinny tree top
tile_treesb:   addtile(treesb,  tile_treesb,  0)     ;skinny tree bottom
tile_boulder:  addtile(boulder, tile_boulder, 0)
tile_ltreeul1: addtile(ltreeul1,tile_ltreeul2,64)
tile_ltreell1: addtile(ltreell1,tile_ltreell2,64)
tile_ltreeur1: addtile(ltreeur1,tile_ltreeur2,64)
tile_ltreelr1: addtile(ltreelr1,tile_ltreelr2,64)
tile_lgrassul1: addtile(lgrassul1,tile_lgrassul2,0)
tile_lgrassll1: addtile(lgrassll1,tile_lgrassll2,0)
tile_lgrassur1: addtile(lgrassur1,tile_lgrassur2,0)
tile_lgrasslr1: addtile(lgrasslr1,tile_lgrasslr2,0)

tile_bmp00:	addtile(bmptiles,tile_bmp00,0)
tile_bmp01:	addtile(bmptiles+8,tile_bmp01,0)
tile_bmp02:	addtile(bmptiles+16,tile_bmp02,0)
tile_bmp03:	addtile(bmptiles+24,tile_bmp03,0)
tile_bmp04:	addtile(bmptiles+32,tile_bmp04,0)
tile_bmp05:	addtile(bmptiles+40,tile_bmp05,0)
tile_bmp06:	addtile(bmptiles+48,tile_bmp06,0)
tile_bmp07:	addtile(bmptiles+56,tile_bmp07,0)
tile_bmp08:	addtile(bmptiles+64,tile_bmp08,0)
tile_bmp09:	addtile(bmptiles+72,tile_bmp09,0)
tile_bmp10:	addtile(bmptiles+80,tile_bmp10,0)
tile_bmp11:	addtile(bmptiles+88,tile_bmp11,0)
tile_bmp12:	addtile(bmptiles+96,tile_bmp12,0)
tile_bmp13:	addtile(bmptiles+104,tile_bmp13,0)


tile_pokheal2: addtile(pokheal2,tile_pokheal1,0)
tile_water2:   addtile(water2, tile_water1,128)
tile_flower2:  addtile(flower2,tile_flower1,128)
tile_ltreeul2: addtile(ltreeul2,tile_ltreeul1,64)
tile_ltreell2: addtile(ltreell2,tile_ltreell1,64)
tile_ltreeur2: addtile(ltreeur2,tile_ltreeur1,64)
tile_ltreelr2: addtile(ltreelr2,tile_ltreelr1,64)
tile_lgrassul2: addtile(lgrassul2,tile_lgrassul1,0)
tile_lgrassll2: addtile(lgrassll2,tile_lgrassll1,0)
tile_lgrassur2: addtile(lgrassur2,tile_lgrassur1,0)
tile_lgrasslr2: addtile(lgrasslr2,tile_lgrasslr1,0)


boulder:
.db %00000000,%01101110,%10110101,%10100101,%01010111,%10011001,%10010011,%01101110
ltreeul1:
.db %00000011,%00011100,%00100010,%01000000,%01010000,%10000000,%10001000,%10000000
ltreell1:
.db %10000000,%10000000,%01100000,%00011111,%00000110,%00000101,%00001010,%00011111
ltreeur1:
.db %11000000,%00111000,%00000100,%01000010,%00000010,%00010001,%00000001,%00000001
ltreelr1:
.db %00000001,%00001001,%10000110,%01111000,%11100000,%01100000,%10110000,%11111000
lgrassul1:
.db %11100110,%01011010,%00101010,%00101010,%11101100,%10001010,%10011010,%01010010
lgrassll1:
.db %01001001,%01001001,%00101001,%01100101,%00100101,%00100101,%00010001,%00001110
lgrassur1:
.db %11001110,%10110100,%10101000,%10101000,%01101110,%10110010,%10010010,%10100100
lgrasslr1:
.db %00100100,%00100100,%00101000,%01001100,%01001000,%01001000,%00010000,%11100000

ltreeul2:
.db %00000011,%00011100,%00100001,%01000000,%01000000,%10001000,%10000100,%10000000
ltreell2:
.db %10000000,%10000000,%01100001,%00011110,%00000110,%00000101,%00001010,%00011111
ltreeur2:
.db %11000000,%00111000,%00000100,%01000010,%00000010,%00001001,%00000001,%00000001
ltreelr2:
.db %00001001,%00000001,%01000110,%01111000,%11100000,%01100000,%10110000,%11111000
lgrassul2:
.db %01110010,%01001101,%00100101,%00100101,%11100101,%10110110,%10010101,%01010101
lgrassll2:
.db %01001010,%01001010,%00101010,%00101010,%00100101,%00010101,%00010001,%00001110
lgrassur2:
.db %01001110,%10110010,%10100100,%10100100,%10100111,%01101101,%10101001,%10101010
lgrasslr2:
.db %01010010,%01010010,%01010100,%01010100,%10100100,%10101000,%10001000,%01110000
treest:
 .db $18,$34,$2C,$56,$4A,$46,$83,$85
treesb:
 .db $83,$85,$4A,$34,$18,$18,$18,$3C
roofleft:
 .db $0F,$38,$E8,$A8,$A8,$AF,$B8,$E0
roofmid:
 .db $FF,$00,$00,$00,$00,$FF,$00,$00
roofrgt:
 .db $F0,$1C,$17,$15,$15,$F5,$1D,$07
poklft:
 .db $20,$20,$20,$20,$20,$20,$20,$20
pokrgt:
 .db $04,$04,$04,$04,$04,$04,$04,$04
pokll:
 .db $20,$20,$20,$20,$30,$2A,$3D,$1F
poklm:
 .db $7E,$81,$81,$85,$81,$81,$81,$FF
poklr:
 .db $04,$04,$04,$04,$04,$04,$9C,$F8
pokheal1:
 .db $00,$40,$A6,$A9,$6E,$10,$52,$FF
pokheal2:
 .db $00,$06,$CA,$AA,$6C,$10,$94,$FF
pokmerc:
 .db $1C,$3E,$7F,$77,$49,$22,$1C,$FF

blank:
 .db 0,0,0,0,0,0,0,0
flower1:
 .db $44,$AA,$44,$00,$22,$55,$22,$00
flower2:
 .db $22,$55,$22,$00,$44,$AA,$44,$00
grass:
 .db $00,$66,$55,$33,$00,$66,$55,$33
;grassalt:
; .db $00,$55,$77,$22,$00,$55,$77,$22

bush:
 .db $18,$34,$4A,$85,$8B,$76,$18,$3C
vine:
 .db $91,$7E,$52,$89,$91,$4A,$7E,$89
water1:
 .db $44,$AA,$11,$00,$22,$55,$88,$00
water2:
 .db $11,$AA,$44,$00,$88,$55,$22,$00

bmptiles:
.option bm_min_w = 8
.option bm_shd = 2
#include "omnirpg\tiles.bmp"


blacktile:
 .dw -1,-1,-1,-1
SaveFileName:
     .db 15h,"OmRPGSav"
defaultsave:
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db "Zeda T.",0,0,0



validate()