#define LCDDelay()		.db $DB,$10,$87,$38,$FB
#define option(str,ptr,offset)	.db str,$FF \ .dw textspd \ .db offset,$D6
#define item(str)		.db str,$D6
#define addtile(tile,evolve,dur) .dw tile \ .db (evolve-TileData)/4,dur

lFont_record	equ 845Ah	;16 bytes
curframe	equ 8000h
curkey		equ 843Fh
lastkey		equ 8440h
keycount	equ 8441h
keydebounced	equ 8442h
animsubcount	equ 8443h	;not used
;OP6
mapwidth       equ 84AFh
mapheight      equ 84B1h
xoffset        equ 84B3h
yoffset        equ 84B5h
tilemapdata    equ 84B7h
mapID          equ 84B9h   ;1-byte, used for when special tiles are walked on

;OP5
TempWord1	equ 84A4h
TempWord2	equ 84A6h
TempWord3	equ 84A8h
TempWord4	equ 84AAh
TempWord5	equ 84ACh
xmapcoord	equ TempWord5
ymapcoord	equ TempWord5+1
playerdir	equ 84AEh

;OP4
DrawBufPtr	equ 8499h
primarybufptr	equ 849Bh
secondarybufptr equ 849Dh
fmt_leftmost	equ 849Fh
fmt_rightmost	equ 84A0h
fmt_lower	equ 84A1h
fmt_upper	equ 84A2h
newlineinc	equ 84A3h

;OP3
textcol		equ 848Eh
textrow		equ 848Fh
fontptr		equ 8490h
mapcurptr	equ 8492h
y = 8494h
x = 8495h

;OP2
ycur = 8483h
xcur = 8485h
adjust = 8487h
tileptr = 8489h

;OP1
curdrawptr = 8481h


apperr1 = 984Dh	;13 bytes
apperr2 = 985Ah	;13 bytes

forcedkeyptr	= apperr1		;2
fkrepeatkey	= forcedkeyptr+2	;1
fkrepeat	= fkrepeatkey+1		;1
fkdelaycount	= fkrepeat+1		;1
fkdelaybase	= fkdelaycount+1	;1
PokedexInfoLUT	= fkdelaybase+1		;2
PokemonSpriteLUT = PokedexInfoLUT+2	;2
tilepalletptr	= PokemonSpriteLUT+2	;2
interruptStkRstr = tilepalletptr+2	;2
StkRstr		= tilepalletptr+4	;2



textShadow	equ 8508h
cmdShadow	equ 966Eh		;128 bytes
RectData	equ textShadow+104
TSBG		equ RectData


OP1		equ 8478h
rect_FirstByte	equ OP1+9
rect_LastByte	equ OP1+10
OP2		equ OP1+11
plotSScreen	equ 9340h
GBUF_LSB	equ 40h
GBUF_MSB	equ 93h


_ExitApp	equ 4027h
_CreateAppVar	equ 4E6Ah
_FlashToRam2	equ 8054h

asmflags	equ 21h
lcdupdate	equ 0
drawmap		equ 1
forcedkey	equ 2
gray		equ 3
graybitmask	equ 4
rvideo		equ 5
tempflag1	equ 6
tempflag2	equ 7

asmflags2	equ 22h
drawmapveto	equ 0
keyready	equ 1	;used by the key hook to learn when a key has been read for use.
mapedit		equ 2

textflags	equ 23h
wordwrap	equ 0
textinverse	equ 1
mapmode		equ 2



buf0 = 9872h
buf1 = 86ECh

SaveSize	equ 1024
saveloc		equ 9D95h
textspd		equ saveloc	;1
badges		equ saveloc+1	;1
cycles		equ saveloc+2	;4
pokedexinfo	equ saveloc+SaveSize-18
NameLoc		equ saveloc+SaveSize-10
playername	equ NameLoc

pcbox		equ saveloc+1024
eventtable	equ saveloc+2048


;Routines and inputs/outputs:
;
;RectangleOR,RectangleXOR,RectangleErase,RectangleBoxEraseFill
; Inputs:
;	DE = (x,y)
;	BC = (height,width)
; Outputs:
;	DE,BC preserved
;

;tokens
t_newline	= 1
t_The		= 2
t_If		= 3
t_Hello		= 4
t_Hi		= 5
t_thelow	= 6
t_game		= 7
t_and		= 8
t_exclam	= 9
t_period	= 10
t_comma		= 11
t_question	= 12
t_Options	= 13
t_Exit		= 14
t_slow		= 15
t_normal	= 16
t_fast		= 17
t_Pokedex	= 18
t_Pokemon	= 19
t_Save		= 20
